{
This component for enable/disable keyboard.
Klavyenizin kontrolu artik elinizde!
izzet uslu
istanbul-TURKEY
http://members.xoom.com/izus
izus6@hotmail.com
}
unit EDKeyb;
{$R EDKeyb.res}

interface

uses
  Windows, Messages, Classes, Controls, Forms, dsgnintf,WinTypes,Winprocs;

type

  TAboutProperty = class(TPropertyEditor)
  private
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

  TDisableEnableKeyboard = class(TComponent)
  private
    { Private declarations }
    FAbout:TAboutProperty;
  protected
    { Protected declarations }
  public
    function  Disable : boolean;
    procedure Enable;
  published
    { Published declarations }
    property About : TAboutProperty read FAbout write FAbout;
  end;

procedure Register;
var oldHook: HHook;

implementation

function KbHook( code: Integer; wparam: Word; lparam: LongInt ): LongInt;
begin
  if code < 0 then
     KbHook := CallNextHookEx( oldHook, code, wparam, lparam )
  else
     KbHook := 1;
end;

function TDisableEnableKeyboard.Disable : boolean;
begin
  oldHook := SetWindowsHookEx( WH_KEYBOARD, @KbHook, HInstance, 0 );
  Disable := oldHook <> 0;
end;

procedure TDisableEnableKeyboard.Enable;
begin
  if oldHook <> 0 then begin
     UnhookWindowshookEx( oldHook );
     oldHook := 0;
  end;
end;

{ TAboutProperty }

procedure TAboutProperty.Edit;
begin
  Application.MessageBox('By izzet uslu - 2000'#13#13'E-Mail : izus6@hotmail.com'#13'WEB : http://members.xoom.com/izus','DisableEnableKeyboard component version 1.0', MB_OK+ MB_ICONINFORMATION);
end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  GetAttributes:=[paDialog, paReadOnly];
end;

function TAboutProperty.GetValue: string;
begin
  GetValue:='(About)';
end;


procedure Register;
begin
  RegisterComponents('izus', [TDisableEnableKeyboard]);
  RegisterPropertyEditor(TypeInfo(TAboutProperty), TDisableEnableKeyboard, 'ABOUT', TAboutProperty);
end;

begin
  oldHook:=0;
end.
